Index: trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/src/G4FermiPhaseSpaceDecay.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/src/G4FermiPhaseSpaceDecay.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/fermi_breakup/src/G4FermiPhaseSpaceDecay.cc	(revision 1315)
@@ -37,4 +37,11 @@
 #include <functional>
 
+G4FermiPhaseSpaceDecay::G4FermiPhaseSpaceDecay()
+{
+}
+
+G4FermiPhaseSpaceDecay::~G4FermiPhaseSpaceDecay()
+{
+}
 
 std::vector<G4LorentzVector*> *
Index: trunk/source/processes/hadronic/models/de_excitation/fission/include/G4FissionBarrier.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/fission/include/G4FissionBarrier.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/fission/include/G4FissionBarrier.hh	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4FissionBarrier.hh,v 1.3 2006/06/29 20:13:21 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4FissionBarrier.hh,v 1.5 2009/12/16 16:50:07 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/fission/src/G4CompetitiveFission.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/fission/src/G4CompetitiveFission.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/fission/src/G4CompetitiveFission.cc	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4CompetitiveFission.cc,v 1.11 2009/03/13 18:57:17 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4CompetitiveFission.cc,v 1.12 2010/05/03 16:49:19 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -38,4 +38,5 @@
 #include "G4CompetitiveFission.hh"
 #include "G4PairingCorrection.hh"
+#include "G4ParticleMomentum.hh"
 
 G4CompetitiveFission::G4CompetitiveFission() : G4VEvaporationChannel("fission")
Index: trunk/source/processes/hadronic/models/de_excitation/fission/src/G4FissionBarrier.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/fission/src/G4FissionBarrier.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/fission/src/G4FissionBarrier.cc	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4FissionBarrier.cc,v 1.5 2006/06/29 20:13:35 gunter Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4FissionBarrier.cc,v 1.7 2009/12/16 16:50:07 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/include/G4EvaporationGEMFactory.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/include/G4EvaporationGEMFactory.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/include/G4EvaporationGEMFactory.hh	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4EvaporationGEMFactory.hh,v 1.7 2009/09/15 12:54:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4EvaporationGEMFactory.hh,v 1.8 2010/04/27 11:43:16 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -41,9 +41,9 @@
 {
 public:
-  G4EvaporationGEMFactory() {}
-  virtual ~G4EvaporationGEMFactory() {}
+  G4EvaporationGEMFactory();
+  virtual ~G4EvaporationGEMFactory(); 
 
 private:
-  G4EvaporationGEMFactory(const G4EvaporationGEMFactory & ) : G4VEvaporationFactory() {}
+  G4EvaporationGEMFactory(const G4EvaporationGEMFactory & );
   const G4EvaporationGEMFactory & operator=(const G4EvaporationGEMFactory & val);
   G4bool operator==(const G4EvaporationGEMFactory & val) const;
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/include/G4GEMProbability.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/include/G4GEMProbability.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/include/G4GEMProbability.hh	(revision 1315)
@@ -24,4 +24,10 @@
 // ********************************************************************
 //
+// $Id: G4GEMProbability.hh,v 1.4 2010/05/19 10:21:16 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+//
+//---------------------------------------------------------------------
+//
+// Geant4 header G4GEMProbability
 //
 //
@@ -29,6 +35,8 @@
 // by V. Lara (Sept 2001) 
 //
-
-
+// 18.05.2010 V.Ivanchenko trying to speedup the most slow method
+//            by usage of G4Pow, integer Z and A; moved constructor, 
+//            destructor and virtual functions to source
+//
 
 #ifndef G4GEMProbability_h
@@ -42,133 +50,150 @@
 #include "G4PairingCorrection.hh"
 
+class G4Pow;
+
 class G4GEMProbability : public G4VEmissionProbability
 {
 public:
-    // Only available constructor
-    G4GEMProbability(const G4int anA, const G4int aZ, const G4double aSpin) : 
-        theA(anA), theZ(aZ), Spin(aSpin), theCoulombBarrierPtr(0),
-        ExcitationEnergies(0), ExcitationSpins(0), ExcitationLifetimes(0), Normalization(1.0)
-        {
-            theEvapLDPptr = new G4EvaporationLevelDensityParameter;
-        }
+
+  // Default constructor - should not be used
+  G4GEMProbability();
+
+  // Only available constructor
+  G4GEMProbability(const G4int anA, const G4int aZ, const G4double aSpin);
     
-    ~G4GEMProbability()
-        {
-            if (theEvapLDPptr != 0) delete theEvapLDPptr;
-        }
+  virtual ~G4GEMProbability();
 
+  inline G4int GetZ_asInt(void) const { return theZ; }
+	
+  inline G4int GetA_asInt(void) const { return theA;}
+	
+  inline G4double GetZ(void) const { return theZ; }
+	
+  inline G4double GetA(void) const { return theA;}
 
-	
-    G4double GetZ(void) const { return theZ; }
-	
-    G4double GetA(void) const { return theA;}
+  inline G4double GetSpin(void) const { return Spin; }
 
-    G4double GetSpin(void) const { return Spin; }
+  inline G4double GetNormalization(void) const { return Normalization; }
+    
+  inline void SetCoulomBarrier(const G4VCoulombBarrier * aCoulombBarrierStrategy)
+  {
+    theCoulombBarrierPtr = aCoulombBarrierStrategy;
+  }
 
-    G4double GetNormalization(void) const { return Normalization; }
+  inline G4double GetCoulombBarrier(const G4Fragment& fragment) const 
+  {
+    G4double res = 0.0;
+    if (theCoulombBarrierPtr) 
+      {
+	G4int Acomp = fragment.GetA_asInt();
+	G4int Zcomp = fragment.GetZ_asInt();
+	res = theCoulombBarrierPtr->GetCoulombBarrier(Acomp-theA, Zcomp-theZ,
+	  fragment.GetExcitationEnergy()-fPairCorr->GetPairingCorrection(Acomp,Zcomp));
+      }
+    return res;
+  }
     
-    void SetCoulomBarrier(const G4VCoulombBarrier * aCoulombBarrierStrategy)
-        {
-            theCoulombBarrierPtr = aCoulombBarrierStrategy;
-        }
-
-    G4double GetCoulombBarrier(const G4Fragment& fragment) const 
-        {
-            if (theCoulombBarrierPtr) 
-	      {
-		G4int Acompound = static_cast<G4int>(fragment.GetA());
-		G4int Zcompound = static_cast<G4int>(fragment.GetZ());
-		return theCoulombBarrierPtr->GetCoulombBarrier(Acompound-theA, Zcompound-theZ,
-							       fragment.GetExcitationEnergy()-
-							       G4PairingCorrection::GetInstance()->
-							       GetPairingCorrection(Acompound,Zcompound));
-	      }
-            else 
-	      {
-		return 0.0;
-	      }
-        }
-    
-
-    virtual G4double CalcAlphaParam(const G4Fragment & ) const {return 1.0;}
-    virtual G4double CalcBetaParam(const G4Fragment & ) const {return 1.0;}
+  virtual G4double CalcAlphaParam(const G4Fragment & ) const;
+  virtual G4double CalcBetaParam(const G4Fragment & ) const;
     
 protected:
   
-    void SetExcitationEnergiesPtr(std::vector<G4double> * anExcitationEnergiesPtr) 
-        {
-            ExcitationEnergies = anExcitationEnergiesPtr;
-        }
+  inline void SetExcitationEnergiesPtr(std::vector<G4double> * anExcitationEnergiesPtr) 
+  {
+    ExcitationEnergies = anExcitationEnergiesPtr;
+  }
   
-    void SetExcitationSpinsPtr(std::vector<G4double> * anExcitationSpinsPtr)
-        {
-            ExcitationSpins = anExcitationSpinsPtr;
-        }
+  inline void SetExcitationSpinsPtr(std::vector<G4double> * anExcitationSpinsPtr)
+  {
+    ExcitationSpins = anExcitationSpinsPtr;
+  }
 
-    void SetExcitationLifetimesPtr(std::vector<G4double> * anExcitationLifetimesPtr)
-        {
-            ExcitationLifetimes = anExcitationLifetimesPtr;
-        }
+  inline void SetExcitationLifetimesPtr(std::vector<G4double> * anExcitationLifetimesPtr)
+  {
+    ExcitationLifetimes = anExcitationLifetimesPtr;
+  }
 
-    void SetCoulombBarrierStrategy(G4VCoulombBarrier * aCoulombBarrier)
-        {
-            theCoulombBarrierPtr = aCoulombBarrier;
-        }
+  inline void SetCoulombBarrierStrategy(G4VCoulombBarrier * aCoulombBarrier)
+  {
+    theCoulombBarrierPtr = aCoulombBarrier;
+  }
 
-  
-    // Default constructor
-    G4GEMProbability() {}
 private:
-    // Copy constructor
-    G4GEMProbability(const G4GEMProbability &right);
+
+  // Copy constructor
+  G4GEMProbability(const G4GEMProbability &right);
     
-    const G4GEMProbability & operator=(const G4GEMProbability &right);
-    G4bool operator==(const G4GEMProbability &right) const;
-    G4bool operator!=(const G4GEMProbability &right) const;
+  const G4GEMProbability & operator=(const G4GEMProbability &right);
+  G4bool operator==(const G4GEMProbability &right) const;
+  G4bool operator!=(const G4GEMProbability &right) const;
     
 public:
-    G4double EmissionProbability(const G4Fragment & fragment, const G4double anEnergy);
+
+  G4double EmissionProbability(const G4Fragment & fragment, const G4double anEnergy);
   
 private:
 
-    G4double CalcProbability(const G4Fragment & fragment, const G4double MaximalKineticEnergy,
-                             const G4double V);
-    virtual G4double CCoeficient(const G4double ) const {return 0.0;};
+  G4double CalcProbability(const G4Fragment & fragment, const G4double MaximalKineticEnergy,
+			   const G4double V);
 
+  virtual G4double CCoeficient(const G4double ) const;
+
+  inline G4double I0(const G4double t);
+  inline G4double I1(const G4double t, const G4double tx);
+  inline G4double I2(const G4double s, const G4double sx);
+  G4double I3(const G4double s, const G4double sx);
     
-    G4double I0(const G4double t);
-    G4double I1(const G4double t, const G4double tx);
-    G4double I2(const G4double s, const G4double sx);
-    G4double I3(const G4double s, const G4double sx);
+  // Data Members
+
+  G4Pow*   fG4pow;
+  G4PairingCorrection* fPairCorr;
     
-    // Data Members
+  G4VLevelDensityParameter * theEvapLDPptr;
+	
+  G4int theA;
+  G4int theZ;
     
-    G4VLevelDensityParameter * theEvapLDPptr;
-	
-    G4int theA;
-    G4int theZ;
+  // Spin is fragment spin
+  G4double Spin;
+
+  // Coulomb Barrier
+  const G4VCoulombBarrier * theCoulombBarrierPtr;
+  
+  // Resonances Energy
+  std::vector<G4double> * ExcitationEnergies;
     
-    // Spin is fragment spin
-    G4double Spin;
+  // Resonances Spin 
+  std::vector<G4double> * ExcitationSpins;
 
-    // Coulomb Barrier
-    const G4VCoulombBarrier * theCoulombBarrierPtr;
+  // Resonances half lifetime
+  std::vector<G4double> * ExcitationLifetimes;
 
-    
-    // Resonances Energy
-    std::vector<G4double> * ExcitationEnergies;
-    
-    // Resonances Spin 
-    std::vector<G4double> * ExcitationSpins;
-
-    // Resonances half lifetime
-    std::vector<G4double> * ExcitationLifetimes;
-
-
-    // Normalization
-    G4double Normalization;
+  // Normalization
+  G4double Normalization;
     
 };
 
+inline G4double G4GEMProbability::I0(const G4double t)
+{
+  return std::exp(t) - 1.0;
+}
+
+inline G4double G4GEMProbability::I1(const G4double t, const G4double tx)
+{
+  return (t - tx + 1.0)*std::exp(tx) - t - 1.0;
+}
+
+
+inline G4double G4GEMProbability::I2(const G4double s, const G4double sx)
+{
+  G4double S = 1.0/std::sqrt(s);
+  G4double Sx = 1.0/std::sqrt(sx);
+  
+  G4double p1 = S*S*S*( 1.0 + S*S*( 1.5 + 3.75*S*S) );
+  G4double p2 = Sx*Sx*Sx*( 1.0 + Sx*Sx*( 1.5 + 3.75*Sx*Sx) )*std::exp(sx-s);
+  
+  return p1-p2;
+}
+
 
 #endif
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4EvaporationGEMFactory.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4EvaporationGEMFactory.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4EvaporationGEMFactory.cc	(revision 1315)
@@ -25,6 +25,6 @@
 //
 //
-// $Id: G4EvaporationGEMFactory.cc,v 1.9 2009/09/15 12:54:16 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4EvaporationGEMFactory.cc,v 1.10 2010/04/27 11:43:16 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -103,24 +103,9 @@
 #include "G4PhotonEvaporation.hh"
 
-const G4EvaporationGEMFactory & 
-G4EvaporationGEMFactory::operator=(const G4EvaporationGEMFactory & )
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationGEMFactory::operator= meant to not be accessable.");
-  return *this;
-}
-
-G4bool 
-G4EvaporationGEMFactory::operator==(const G4EvaporationGEMFactory & ) const
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationGEMFactory::operator== meant to not be accessable.");
-  return false;
-}
-
-G4bool 
-G4EvaporationGEMFactory::operator!=(const G4EvaporationGEMFactory & ) const
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4EvaporationGEMFactory::operator!= meant to not be accessable.");
-  return true;
-}
+G4EvaporationGEMFactory::G4EvaporationGEMFactory()
+{} 
+  
+G4EvaporationGEMFactory::~G4EvaporationGEMFactory() 
+{}
                  
 std::vector<G4VEvaporationChannel*> * G4EvaporationGEMFactory::CreateChannel()
@@ -129,4 +114,7 @@
     new std::vector<G4VEvaporationChannel*>;
   theChannel->reserve(68);
+
+  theChannel->push_back( new G4PhotonEvaporation() );  // Photon Channel
+  theChannel->push_back( new G4CompetitiveFission() ); // Fission Channel
 
   theChannel->push_back( new G4NeutronGEMChannel() );  // n
@@ -197,7 +185,4 @@
   theChannel->push_back( new G4Mg28GEMChannel() );     // Mg28
 
-  theChannel->push_back( new G4CompetitiveFission() ); // Fission Channel
-  theChannel->push_back( new G4PhotonEvaporation() );  // Photon Channel
-
   return theChannel;
 }
Index: trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMProbability.cc
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMProbability.cc	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/gem_evaporation/src/G4GEMProbability.cc	(revision 1315)
@@ -24,4 +24,14 @@
 // ********************************************************************
 //
+// $Id: G4GEMProbability.cc,v 1.13 2010/05/19 10:21:16 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
+//
+//---------------------------------------------------------------------
+//
+// Geant4 class G4GEMProbability
+//
+//
+// Hadronic Process: Nuclear De-excitations
+// by V. Lara (Sept 2001) 
 //
 //
@@ -35,34 +45,51 @@
 //       -InitialLeveldensity calculated according to the right conditions of the 
 //        initial excited nucleus.
+// J. M. Quesada 19/04/2010 fix in  emission probability calculation.
+// V.Ivanchenko  20/04/2010 added usage of G4Pow and use more safe computation
+// V.Ivanchenko 18/05/2010 trying to speedup the most slow method
+//            by usage of G4Pow, integer Z and A; moved constructor, 
+//            destructor and virtual functions to source
 
 #include "G4GEMProbability.hh"
 #include "G4PairingCorrection.hh"
-
-
-
-G4GEMProbability::G4GEMProbability(const G4GEMProbability &) : G4VEmissionProbability()
-{
-    throw G4HadronicException(__FILE__, __LINE__, "G4GEMProbability::copy_constructor meant to not be accessable");
-}
-
-
-
-
-const G4GEMProbability & G4GEMProbability::
-operator=(const G4GEMProbability &)
-{
-  throw G4HadronicException(__FILE__, __LINE__, "G4GEMProbability::operator= meant to not be accessable");
-  return *this;
-}
-
-
-G4bool G4GEMProbability::operator==(const G4GEMProbability &) const
-{
-  return false;
-}
-
-G4bool G4GEMProbability::operator!=(const G4GEMProbability &) const
-{
-  return true;
+#include "G4Pow.hh"
+#include "G4IonTable.hh"
+
+G4GEMProbability:: G4GEMProbability() : 
+  theA(0), theZ(0), Spin(0.0), theCoulombBarrierPtr(0),
+  ExcitationEnergies(0), ExcitationSpins(0), ExcitationLifetimes(0), Normalization(1.0)
+{
+  theEvapLDPptr = new G4EvaporationLevelDensityParameter;
+  fG4pow = G4Pow::GetInstance(); 
+  fPairCorr = G4PairingCorrection::GetInstance();
+}
+
+G4GEMProbability:: G4GEMProbability(const G4int anA, const G4int aZ, const G4double aSpin) : 
+  theA(anA), theZ(aZ), Spin(aSpin), theCoulombBarrierPtr(0),
+  ExcitationEnergies(0), ExcitationSpins(0), ExcitationLifetimes(0), Normalization(1.0)
+{
+  theEvapLDPptr = new G4EvaporationLevelDensityParameter;
+  fG4pow = G4Pow::GetInstance(); 
+  fPairCorr = G4PairingCorrection::GetInstance();
+}
+    
+G4GEMProbability::~G4GEMProbability()
+{
+  delete theEvapLDPptr;
+}
+
+G4double G4GEMProbability::CalcAlphaParam(const G4Fragment & ) const 
+{
+  return 1.0;
+}
+
+G4double G4GEMProbability::CalcBetaParam(const G4Fragment & ) const 
+{
+  return 1.0;
+}
+
+G4double G4GEMProbability::CCoeficient(const G4double ) const 
+{
+  return 0.0;
 }
 
@@ -80,5 +107,5 @@
     if (ExcitationEnergies  &&  ExcitationSpins && ExcitationLifetimes) {
       G4double SavedSpin = Spin;
-      for (unsigned int i = 0; i < ExcitationEnergies->size(); i++) {
+      for (size_t i = 0; i < ExcitationEnergies->size(); ++i) {
 	Spin = ExcitationSpins->operator[](i);
 	// substract excitation energies
@@ -86,6 +113,8 @@
 	if (Tmax > 0.0) {
 	  G4double width = CalcProbability(fragment,Tmax,CoulombBarrier);
+	  //JMQ April 2010 added condition to prevent reported crash
 	  // update probability
-	  if (hbar_Planck*std::log(2.0)/width < ExcitationLifetimes->operator[](i)) {
+	  if (width > 0. && 
+	      hbar_Planck*fG4pow->logZ(2) < width*ExcitationLifetimes->operator[](i)) {
 	    EmissionProbability += width;
 	  }
@@ -98,4 +127,139 @@
   return EmissionProbability;
 }
+
+
+G4double G4GEMProbability::CalcProbability(const G4Fragment & fragment, 
+                                           const G4double MaximalKineticEnergy,
+                                           const G4double V)
+
+// Calculate integrated probability (width) for evaporation channel
+{
+  G4int A = fragment.GetA_asInt();
+  G4int Z = fragment.GetZ_asInt();
+
+  G4int ResidualA = A - theA;
+  G4int ResidualZ = Z - theZ;
+  G4double U = fragment.GetExcitationEnergy();
+  
+  G4double NuclearMass = fragment.ComputeGroundStateMass(theZ, theA);
+  
+  G4double Alpha = CalcAlphaParam(fragment);
+  G4double Beta = CalcBetaParam(fragment);
+  
+  
+  //                       ***RESIDUAL***
+  //JMQ (September 2009) the following quantities refer to the RESIDUAL:
+  
+  G4double delta0 = fPairCorr->GetPairingCorrection(ResidualA, ResidualZ);  
+  
+  G4double a = theEvapLDPptr->LevelDensityParameter(ResidualA,
+  						    ResidualZ,MaximalKineticEnergy+V-delta0);
+  G4double Ux = (2.5 + 150.0/G4double(ResidualA))*MeV;
+  G4double Ex = Ux + delta0;
+  G4double T  = 1.0/(std::sqrt(a/Ux) - 1.5/Ux);
+  //JMQ fixed bug in units
+  G4double E0 = Ex - T*(std::log(T/MeV) - std::log(a*MeV)/4.0 - 1.25*std::log(Ux/MeV) + 2.0*std::sqrt(a*Ux));
+  //                      ***end RESIDUAL ***
+  
+  //                       ***PARENT***
+  //JMQ (September 2009) the following quantities refer to the PARENT:
+     
+  G4double deltaCN=fPairCorr->GetPairingCorrection(A, Z);				       
+  G4double aCN = theEvapLDPptr->LevelDensityParameter(A, Z, U-deltaCN);
+  G4double UxCN = (2.5 + 150.0/G4double(A))*MeV;
+  G4double ExCN = UxCN + deltaCN;
+  G4double TCN = 1.0/(std::sqrt(aCN/UxCN) - 1.5/UxCN);
+  //JMQ fixed bug in units
+  G4double E0CN = ExCN - TCN*(std::log(TCN/MeV) - std::log(aCN*MeV)/4.0 - 1.25*std::log(UxCN/MeV) + 2.0*std::sqrt(aCN*UxCN));
+//                       ***end PARENT***
+
+  G4double Width;
+  G4double InitialLevelDensity;
+  G4double t = MaximalKineticEnergy/T;
+  if ( MaximalKineticEnergy < Ex ) {
+    //JMQ 190709 bug in I1 fixed (T was  missing)
+    Width = (I1(t,t)*T + (Beta+V)*I0(t))/std::exp(E0/T);
+    //JMQ 160909 fix:  InitialLevelDensity has been taken away 
+    //(different conditions for initial CN..) 
+  } else {
+
+    //VI minor speedup
+    G4double expE0T = std::exp(E0/T);
+    const G4double sqrt2 = std::sqrt(2.0);
+
+    G4double tx = Ex/T;
+    G4double s = 2.0*std::sqrt(a*(MaximalKineticEnergy-delta0));
+    G4double sx = 2.0*std::sqrt(a*(Ex-delta0));
+    Width = I1(t,tx)*T/expE0T + I3(s,sx)*std::exp(s)/(sqrt2*a);
+    // For charged particles (Beta+V) = 0 beacuse Beta = -V
+    if (theZ == 0) {
+      Width += (Beta+V)*(I0(tx)/expE0T + 2.0*sqrt2*I2(s,sx)*std::exp(s));
+    }
+  }
+  
+  //JMQ 14/07/2009 BIG BUG : NuclearMass is in MeV => hbarc instead of hbar_planck must be used
+  //    G4double g = (2.0*Spin+1.0)*NuclearMass/(pi2* hbar_Planck*hbar_Planck);
+  G4double g = (2.0*Spin+1.0)*NuclearMass/(pi2* hbarc*hbarc);
+  
+  //JMQ 190709 fix on Rb and  geometrical cross sections according to Furihata's paper 
+  //                      (JAERI-Data/Code 2001-105, p6)
+  //    G4double RN = 0.0;
+  G4double Rb = 0.0;
+  if (theA > 4) 
+    {
+      //	G4double R1 = std::pow(ResidualA,1.0/3.0);
+      //	G4double R2 = std::pow(G4double(theA),1.0/3.0);
+      G4double Ad = fG4pow->Z13(ResidualA);
+      G4double Aj = fG4pow->Z13(theA);
+      //	RN = 1.12*(R1 + R2) - 0.86*((R1+R2)/(R1*R2));
+      Rb = 1.12*(Aj + Ad) - 0.86*((Aj+Ad)/(Aj*Ad))+2.85;
+      Rb *= fermi;
+    }
+  else if (theA>1)
+    {
+      G4double Ad = fG4pow->Z13(ResidualA);
+      G4double Aj = fG4pow->Z13(theA);
+      Rb=1.5*(Aj+Ad)*fermi;
+    }
+  else
+    {
+      G4double Ad = fG4pow->Z13(ResidualA);
+      Rb = 1.5*Ad*fermi;
+    }
+  //   G4double GeometricalXS = pi*RN*RN*std::pow(ResidualA,2./3.); 
+  G4double GeometricalXS = pi*Rb*Rb; 
+  //end of JMQ fix on Rb by 190709
+  
+
+
+//JMQ 160909 fix: initial level density must be calculated according to the 
+// conditions at the initial compound nucleus 
+// (it has been removed from previous "if" for the residual) 
+
+   if ( U < ExCN ) 
+      {
+        InitialLevelDensity = (pi/12.0)*std::exp((U-E0CN)/TCN)/TCN;
+      } 
+    else 
+      {
+	//        InitialLevelDensity = (pi/12.0)*std::exp(2*std::sqrt(aCN*(U-deltaCN)))/std::pow(aCN*std::pow(U-deltaCN,5.0),1.0/4.0);
+	//VI speedup
+        G4double x  = U-deltaCN;
+        G4double x2 = x*x;
+        G4double x3 = x2*x;
+        InitialLevelDensity = (pi/12.0)*std::exp(2*std::sqrt(aCN*x))/std::sqrt(std::sqrt(aCN*x2*x3));
+      }
+ //
+
+
+  //JMQ 190709 BUG : pi instead of sqrt(pi) must be here according to Furihata's report:
+  //    Width *= std::sqrt(pi)*g*GeometricalXS*Alpha/(12.0*InitialLevelDensity); 
+  Width *= pi*g*GeometricalXS*Alpha/(12.0*InitialLevelDensity); 
+   
+
+  return Width;
+}
+
+/*
 
 G4double G4GEMProbability::CalcProbability(const G4Fragment & fragment, 
@@ -219,33 +383,5 @@
   return Width;
 }
-
-
-
-
-G4double G4GEMProbability::I0(const G4double t)
-{
-  G4double result = (std::exp(t) - 1.0);
-  return result;
-}
-
-G4double G4GEMProbability::I1(const G4double t, const G4double tx)
-{
-  G4double result = t - tx + 1.0;
-  result *= std::exp(tx);
-  result -= (t + 1.0);
-  return result;
-}
-
-
-G4double G4GEMProbability::I2(const G4double s, const G4double sx)
-{
-  G4double S = 1.0/std::sqrt(s);
-  G4double Sx = 1.0/std::sqrt(sx);
-  
-  G4double p1 = S*S*S*( 1.0 + S*S*( 1.5 + 3.75*S*S) );
-  G4double p2 = Sx*Sx*Sx*( 1.0 + Sx*Sx*( 1.5 + 3.75*Sx*Sx) )*std::exp(sx-s);
-  
-  return p1-p2;
-}
+*/
 
 G4double G4GEMProbability::I3(const G4double s, const G4double sx)
Index: trunk/source/processes/hadronic/models/de_excitation/handler/include/G4ExcitationHandler.hh
===================================================================
--- trunk/source/processes/hadronic/models/de_excitation/handler/include/G4ExcitationHandler.hh	(revision 1228)
+++ trunk/source/processes/hadronic/models/de_excitation/handler/include/G4ExcitationHandler.hh	(revision 1315)
@@ -24,7 +24,6 @@
 // ********************************************************************
 //
-//
-// $Id: G4ExcitationHandler.hh,v 1.10 2009/11/24 11:18:48 vnivanch Exp $
-// GEANT4 tag $Name: geant4-09-03 $
+// $Id: G4ExcitationHandler.hh,v 1.12 2010/04/27 14:00:23 vnivanch Exp $
+// GEANT4 tag $Name: geant4-09-04-beta-cand-01 $
 //
 // Hadronic Process: Nuclear De-excitations
@@ -55,4 +54,5 @@
 #include "G4VEvaporation.hh"
 #include "G4VPhotonEvaporation.hh"
+#include "G4VEvaporationChannel.hh"
 #include "G4Fragment.hh"
 #include "G4DynamicParticle.hh"
@@ -68,6 +68,4 @@
 #include "G4IonConstructor.hh" 
 
-//#define debug
-
 class G4ExcitationHandler 
 {
@@ -75,13 +73,14 @@
   G4ExcitationHandler(); 
   ~G4ExcitationHandler();
+
 private:
+
   G4ExcitationHandler(const G4ExcitationHandler &right);
-
   const G4ExcitationHandler & operator=(const G4ExcitationHandler &right);
   G4bool operator==(const G4ExcitationHandler &right) const;
   G4bool operator!=(const G4ExcitationHandler &right) const;
   
-
 public:
+
   G4ReactionProductVector * BreakItUp(const G4Fragment &theInitialState) const;
 
@@ -92,5 +91,5 @@
   void SetFermiModel(G4VFermiBreakUp *const  value);
 
-  void SetPhotonEvaporation(G4VPhotonEvaporation * const value);
+  void SetPhotonEvaporation(G4VEvaporationChannel * const value);
 
   void SetMaxZForFermiBreakUp(G4int aZ);
@@ -99,11 +98,13 @@
   void SetMinEForMultiFrag(G4double anE);
 
-// for inverse cross section choice
-  inline void SetOPTxs(G4int opt) { OPTxs = opt;}
-// for superimposed Coulomb Barrir for inverse cross sections
-  inline void UseSICB(){useSICB=true;}
+  // for inverse cross section choice
+  inline void SetOPTxs(G4int opt);
+  // for superimposed Coulomb Barrir for inverse cross sections
+  inline void UseSICB();
 
 private:
 
+  void SetParameters();
+
   G4ReactionProductVector * Transform(G4FragmentVector * theFragmentVector) const;
 
@@ -114,5 +115,5 @@
   const G4VFermiBreakUp * GetFermiModel() const;
 
-  const G4VPhotonEvaporation * GetPhotonEvaporation() const;
+  const G4VEvaporationChannel * GetPhotonEvaporation() const;
 
   G4int GetMaxZ() const;
@@ -124,4 +125,5 @@
 			 G4FragmentVector * Result) const;
 #endif
+
 private:
   
@@ -132,9 +134,10 @@
   G4VFermiBreakUp *theFermiModel;
  
-  G4VPhotonEvaporation * thePhotonEvaporation;
+  G4VEvaporationChannel * thePhotonEvaporation;
 
   G4int maxZForFermiBreakUp;
   G4int maxAForFermiBreakUp;
   G4double minEForMultiFrag;
+  G4double minExcitation;
 
   G4ParticleTable *theTableOfParticles;
@@ -147,5 +150,5 @@
   G4int OPTxs;
   G4bool useSICB;
-
+  
   struct DeleteFragment 
   {
@@ -156,9 +159,18 @@
     }
   };
-
-
+  
 };
 
-
+inline void G4ExcitationHandler::SetOPTxs(G4int opt) 
+{ 
+  OPTxs = opt; 
+  SetParameters();
+}
+
+inline void G4ExcitationHandler::UseSICB()
+{ 
+  useSICB = true; 
+  SetParameters();
+}
 
 inline const G4VEvaporation * G4ExcitationHandler::GetEvaporation() const
@@ -172,4 +184,5 @@
   MyOwnEvaporationClass = false;
   theEvaporation = value;
+  SetParameters();
 }
 
@@ -199,10 +212,10 @@
 
 
-inline const G4VPhotonEvaporation * G4ExcitationHandler::GetPhotonEvaporation() const
+inline const G4VEvaporationChannel * G4ExcitationHandler::GetPhotonEvaporation() const
 {
   return thePhotonEvaporation;
 }
 
-inline void G4ExcitationHandler::SetPhotonEvaporation(G4VPhotonEvaporation *const  value)
+inline void G4ExcitationHandler::SetPhotonEvaporation(G4VEvaporationChannel *const  value)
 {
   if (thePhotonEvaporation != 0 && MyOwnPhotonEvaporationClass) delete thePhotonEvaporation;
